#!/usr/bin/env node
'use strict';

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _baba = require('../baba');

var _baba2 = _interopRequireDefault(_baba);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_yargs2.default.command(['parse <file>', '$0'], 'Parse grammar and output JS module', yargs => yargs.option('minify', {
	describe: 'Minify output',
	default: false
}).option('target-browsers', {
	describe: 'Target browsers (browserslist syntax)',
	type: 'string',
	default: 'last 1 firefox version, last 1 chrome version, last 1 edge version'
}).option('target-node', {
	describe: 'Node target',
	type: 'string',
	default: 'current'
}).positional('file', {
	describe: 'Baba grammar file',
	type: 'string'
}), argv => {
	const script = (0, _baba2.default)(argv.file, {
		browsers: argv.targetBrowsers,
		node: argv.targetNode
	}, argv.minify);

	process.stdout.write(script);
}).argv;